<?php
/**
* @package BUF Framework
* @author jtotal https://jtotal.com
* @copyright Copyright (c) 2019 dibuxo
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 or Later
*/  


//no direct accees
defined ('_JEXEC') or die ('resticted access');

/*jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');
jimport('joomla.registry.registry');
jimport('joomla.image.image'); 
*/

use BUF\BUFfavicon;
use Joomla\CMS\Factory;
use Joomla\CMS\Filesystem\Folder;
use Joomla\Archive\Zip;
use Joomla\CMS\Filesystem\Path;
use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Uri\Uri;

class plgAjaxBufajax extends CMSPlugin
{

    protected $autoloadLanguage = true;

    public static $cachepath;

    function onAjaxBufajax()
    {

        $app = Factory::getApplication();
    	$input = Factory::getApplication()->input;
        $doc = Factory::getDocument();



        $templateid = $input->post->get('templateid', '', 'INT');
        $layout = $input->post->get('buf_layout','default');
        $image = '';

        $action = $input->post->get('action', '', 'STRING');
        //try with get
        if($action=='') $action = $input->get->get('action', '', 'STRING');
        


        //other actions
        if (isset($_POST['data'])) {
            $data = json_decode(json_encode($_POST['data']), true);
            $action = $data['action'];
            $templateid = $data['templateid'];
            $tpath = $data['tpath'];
            $layout = $data['layout'];
        }





        $cachepath = JPATH_SITE.'/cache/buf_'.$layout;
        self::$cachepath = $cachepath;
       


        if(!$templateid) return false;

        //MAIN SWITCH
        $results = array();
        switch ($action) {
                case 'do_bs_sass':
                    //$results['data'] = $tpath;
                    $data = array();
                   
                    $data['debug'] = $this::buf_sass($templateid,'bs');

                    $data["file_data"] = $this::buf_getFileData('buf_bs.css');
                    return $data;
                break;


                case 'do_fa_sass':
                    //$results['data'] = $tpath;
                    $data = array();
                    $data['debug'] = $this::buf_sass($templateid,'fa');
                    $data["file_data"] = $this::buf_getFileData('buf_fa.css');
                    return $data;
                break;


                case 'doreloadsass':
                    $session = Factory::getSession();
                    $session->set('buf_reload_sass','1');
                    return 'ok';
                break;


                case 'doreload_bs_sass':
                    $session = Factory::getSession();
                    $session->set('buf_reload_bs_sass','1');
                    return 'ok';
                break;


                case 'doreload_fa_sass':
                    $session = Factory::getSession();
                    $session->set('buf_reload_fa_sass','1');
                    return 'ok';
                break;


                case 'do_clean_bs':
                    
                    if(file_exists($cachepath. '/buf_bs.css')) unlink($cachepath. '/buf_bs.css');
                    if(file_exists($cachepath. '/buf.css')) unlink($cachepath. '/buf.css');
                    return '<div class="badge badge-warning">'.Text::_( 'TPL_BUF_NOT_EXIST' ).'</div>';
                break;


                case 'do_clean_fa':
                    //$cachepath = JPATH_SITE.'/cache/buf';
                    if(file_exists($cachepath. '/buf_fa.css')) unlink($cachepath. '/buf_fa.css');
                    if(file_exists($cachepath. '/buf.css')) unlink($cachepath. '/buf.css');
                    return '<div class="badge badge-warning">'.Text::_( 'TPL_BUF_NOT_EXIST' ).'</div>';
                break;


                case 'do_clear_cache':
                    //$cachepath = JPATH_SITE.'/cache/buf';                           
                    if (is_dir($cachepath)) {
                        Folder::delete($cachepath);
                        return 'ok';
                    }
                    return 'ko';
                break;


                case 'do_zip_layout':
                    
                    return $this::buf_zip_file($layout, $tpath);
                break;


                case 'do_bs4custom':
                    //$results['data'] = $tpath;
                    $this::buf_sass($templateid,'bs');
                    //return $this::buf_sass($templateid);
                break;


                case 'dofavicon':
                    
                    $image = $data['image'];
                    $results['message'] = $this::buf_favicons($templateid,$image);
                    
                    //return $image;
                    return $results['message'];
                break;


                case 'doreadsccsfile':

                    $tpath = $data['tpath'];

                    //PHP
                    if($data['file']=='layout.php'){
                        $file = 'buf/layouts/'.$data['layout'].'/layout.php';
                        $results['message'] = $this::buf_getPHPfile($templateid,$tpath,$file);
                    }elseif($data['file']=='buf_layout.js'){
                        //JS
                        $file = 'buf/layouts/'.$data['layout'].'/js/'.$data['file'];
                        $results['message'] = $this::buf_getPHPfile($templateid,$tpath,$file);
                    }else{
                        //SCSS
                        $file = 'buf/layouts/'.$data['layout'].'/scss/'.$data['file'];
                         
                        $results['message'] = $this::buf_getSCSSfile($templateid,$tpath,$file);
                    }
                                     
                    
                    return $results['message'];
                break;


                case 'dosavesccsfile':
                    
                    $tpath = $data['tpath'];
                    $text = $data['text'];
                    
                    if($data['file']=='layout.php'){
                        //PHP
                        $file = 'buf/layouts/'.$data['layout'].'/layout.php';
                        $results['message'] = $this::buf_savePHPfile($templateid,$tpath,$file,$text);

                    }elseif($data['file']=='buf_layout.js'){
                        //JS
                        $file = 'buf/layouts/'.$data['layout'].'/js/'.$data['file'];
                        $results['message'] = $this::buf_savePHPfile($templateid,$tpath,$file,$text);
                    }else{
                        //SCSS
                        $file = 'buf/layouts/'.$data['layout'].'/scss/'.$data['file'];
                        $results['message'] = $this::buf_saveSCSSfile($templateid,$tpath,$file,$text);
                    }
                   
                    //return $image;
                    return $results['message'];
                break;

                case 'doduplicatelayout':
                    $tpath = $data['tpath'];
                    $name = $data['name'];
                    $results['message'] = $this::buf_duplicatelayout($templateid,$tpath,$name);
                    
                    //return $image;
                    return $results['message'];
                break;


                case 'do_get_favicon_svg':

                    //BORRAR
                    if($input->get->get('detelesvg', '', 'STRING')=='true'){
                        $this::favicon_svg_delete($layout);
                        return 'deleted';
                    }
                  

                    return $this::favicon_svg_move($templateid,$layout,$_FILES['upload_file_svg']['tmp_name']);
                    return $results['message'];
                break;
/*
                case 'dogetparams':
                    $tpath = $data['tpath'];
                    $name = $data['name'];
                    $results['message'] = $this::buf_duplicatelayout($templateid,$tpath,$name);
                    
                    //return $image;
                    return $results['message'];
                break;
*/


        } 
        return json_encode($results);
    }

    function buf_duplicatelayout($templateid,$tpath,$name){

        $ruta = $tpath.'buf/layouts';

        if(!is_writable($ruta)){
            return "Error. Directory layouts is not writable";
        }

        if (Folder::exists($ruta.'/'.$name)) {
            return "Error. Directory exists!";
        }

        Folder::copy($ruta.'/default', $ruta.'/'.$name);

        return 'OK';
    }

    function buf_zip_file($layout, $tpath){
        
        $l_path = realpath($tpath.'buf/layouts/'.$layout);

        if(is_dir($l_path)){
            
           // store the current joomla working directory
            $j_path = getcwd();
            //change working path to l_path
            chdir($l_path);

            $files = Folder::files('.', '', true, true);
            $data = array();

            foreach($files as $file)
            {
                $tmp = array();
                $tmp['name'] = str_replace('./', '', $file);
                $tmp['data'] = file_get_contents($file);
                $tmp['time'] = filemtime($file);
                $data[] = $tmp;
            }

            $zip_file = $tpath.'buf/layouts/'.$layout.'_'.date('dMy_H\h-i\m').'.zip';
            $archive = new Zip;
            $archive->create($zip_file, $data);

            //security return to j_path
            chdir($j_path);

            $retorno = array(
                'status' => 'ok', 
                'filename' => $layout.'_'.date('dMy_H\h-i\m').'.zip',
                'file_path' => Uri::root().'/templates/buf/layouts/'.$layout.'_'.date('dMy_H\h-i\m').'.zip'
            );

            return $retorno;

            
        }else{

            $retorno = array('status' => 'ko', 'filename' => 'I cant find the folder :/');

            return json_encode($retorno);

        }

    }


    function getCurrentParams($id){

        $db = Factory::getDBO();
        $sql = "SELECT template,params FROM `#__template_styles` WHERE `id` = $id";
        $db->setQuery($sql); 
       // $db->query();
        $row = $db->loadRow();
        $json = $row;

        return $json;
    }

    /*
    //DEPRECATED
    function buf_less($templateid){
        
        include_once JPATH_SITE.'/templates/buf/classes/bufless.php';

        $buffles = new BUFless();
        $runless = $buffles::runless($templateid);
               
        return $runless;
    }
    */

    function buf_sass($templateid,$bs_or_fa=''){
        
        include_once JPATH_SITE.'/templates/buf/classes/bufsass.php';
        $buffles = new BUFsass();
        $runsass = $buffles::runsass($templateid,'','','',$bs_or_fa);

        return $runsass;
    }

    function buf_bs4_custom($templateid){
        
        include_once JPATH_SITE.'/templates/buf/classes/bufsass.php';
        $buffles = new BUFsass();
        $runsass = $buffles::runsass($templateid);

        return $runsass;
    }


    function buf_favicons($templateid, $image){
        
        include_once JPATH_SITE.'/templates/buf/classes/buffavicon.php';
        include_once JPATH_SITE.'/templates/buf/classes/phpico.php';
        //include_once JPATH_SITE.'/templates/buf/classes/phpicongen.php';

        $buffav = new BUFfavicon($templateid);
        $create_fav = $buffav::create_favicons($templateid,$image);

        return $create_fav;
    }


    function buf_getPHPfile($templateid, $tpath, $file){
        
        $scss_file=$file;
        $scss_file=file_get_contents($tpath.$file);
       //$scss_file=$tpath.$file.'.scss';

        return $scss_file;
    }

    function buf_getSCSSfile($templateid, $tpath, $file){
        
        $scss_file=$file;
        $scss_file=file_get_contents($tpath.$file.'.scss');
       //$scss_file=$tpath.$file.'.scss';

        //return $tpath.$file.'.scss';
        return $scss_file;
    }

    function buf_saveSCSSfile($templateid, $tpath, $file, $text){
        
        $scss_file=$file;
        //$scss_file=file_put_contents($tpath.$file.'.scss', $text);
        $sccs_permission = is_writable($tpath.$file.'.scss');

        if($sccs_permission){

          $scss_file=file_put_contents($tpath.$file.'.scss', $text);
          return $file.'.scss';
        }else{
          //error
          return '<span class="buf_error"><i class="fa fa-exclamation-triangle"></i> File'.$file.'.scss NOT WRITABLE</span>';
        }

    }

    function buf_savePHPfile($templateid, $tpath, $file, $text){
        
        $scss_file=$file;
        //$scss_file=file_put_contents($tpath.$file.'.scss', $text);
        $sccs_permission = is_writable($tpath.$file);

        if($sccs_permission){
          $scss_file=file_put_contents($tpath.$file, $text);
          return $file;
        }else{
          //error
          return '<i class="fa fa-exclamation-triangle"></i> File not writable: '.$tpath.$file;
        }

    }

    function buf_getFileData($file){
        $cssfile = self::$cachepath.'/'.$file;
        //$cssfile = self::$cachepath;
        $data = array();

        //set high time limit
        set_time_limit(120);

        //echo "Script began: " . date("d-m-Y h:i:s") . "<br>";

        do {
            if (file_exists($cssfile)) {
                //echo "The file was found: " . date("d-m-Y h:i:s") . "<br>";
                break;
            }
        } while(true);

        $data['file_size'] = "<div>". Text::_( 'TPL_BUF_COMPILATION_SIZE' ) .self::human_filesize($cssfile)."</div>";
        $data['file_date'] = "<div>". Text::_( 'TPL_BUF_COMPILATION_TIME' ) . date ("d-m-y H:i:s", filemtime($cssfile)). "</div>";
        $data['file_name'] = '<div class=""><small>'.$cssfile. '</small></div><div class="badge badge-success">'.Text::_( 'TPL_BUF_COMPILED' ).'</div>';
        


      if($file == 'buf_bs.css'){

        $cleanclass='do_clean_bs';
        $id='compile_bs_sass';

      }elseif($file == 'buf_fa.css'){

        $cleanclass='do_clean_fa';
        $id='compile_fa_sass';

      }else{
        return;
      }

        $data['file_clean'] = '<div class="btn_buf_clean btn"><a href="#" class="'.$cleanclass.'">'. JText::_("TPL_BUF_CLEAN_FILE") .'</a></div>';
       
       return $data;

    }

    private function human_filesize($file, $decimals = 2) {

        $bytes = (int)  filesize($file);
        $sz = 'BKMGTP';
        $factor = floor((strlen($bytes) - 1) / 3);
        return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$sz[$factor];
    }


    //favicon SVG
    private function favicon_svg_move($templateid,$buf_layout, $file) {
        if (extension_loaded('imagick')) {
            try {
                $im = new Imagick($file);
                $svg = file_get_contents($file);
                $im_w = $im->getImageWidth();
                $im_h = $im->getImageHeight();
                if(mime_content_type($file) != 'image/svg+xml') return "error mimetype";

                file_put_contents(JPATH_ROOT . '/templates/buf/layouts/'.$buf_layout.'/icons/svgfavicon.svg',$svg);
            } catch (Exception $e) {
                return false;
            }
            //MOVE
            $file_dest =  URI::root(). 'templates/buf/layouts/'.$buf_layout.'/icons/svgfavicon.svg';

            /*         
            $im->readImageBlob($svg);
            
            //png settings
            $im->setImageFormat("png24");
            $im->resizeImage($im_w, $im_h, imagick::FILTER_LANCZOS, 1);  //Optional, if you need to resize
            

            $im->writeImage(JPATH_ROOT . '/templates/buf/layouts/'.$buf_layout.'/icons/svgfavicon.png');
            $im->clear();  */

            return  $file_dest;
        }

    }

    function favicon_svg_delete($buf_layout) {

        $file = JPATH_ROOT . '/templates/buf/layouts/'.$buf_layout.'/icons/svgfavicon.svg';
        if(file_exists($file)){
            File::delete($file);
            return  true;
        }

        return false;
    }


}